#include "TCP_Client.h"
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <errno.h>
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>

#define BUFLEN 275

int sockfd;
unsigned char* array;

int getPos(int x, int y)
{
	return (y*25)+x;
}

void writeToArray(int in, int pos)
{
	//array[pos/8]=in?array[pos/8]|(0b10000000>>(pos%8)):array[pos/8] & (~(0b10000000>>(pos%8)));
	array[pos] = (unsigned char)(in&0xff);
	//general idea: pixel on -> search char in array, write per bitmask (or)
	//pixel off: search, write per negative bitmask (and) 
}

void resetScreen()
{
	int i;
	for (i=0; i<BUFLEN; i++)
		array[i]=0;
}

void init(char* server_ip, int serverPort)
{    
    struct sockaddr_in their_addr; 	//connector's address information
    struct hostent *he;
    int numbytes;
    array=calloc(BUFLEN,1);

    //Resolve hostname to IP Address
    if ((he=gethostbyname(server_ip)) == NULL) {  // get the host info
        herror("gethostbyname");
        printf("cannot resolve host\n");
        exit(1);
    }

    //create socket
    sockfd = socket(PF_INET,SOCK_STREAM,IPPROTO_IP);
    if (sockfd==-1)
    {
        printf("could not create socket\n");
        exit(1);
    }

    //setup transport address
    their_addr.sin_family = AF_INET;     
    their_addr.sin_port = htons(serverPort);
    their_addr.sin_addr = *((struct in_addr *)he->h_addr_list[0]);
    memset(their_addr.sin_zero, '\0', sizeof their_addr.sin_zero);
    
	//connecting to server
    if (connect(sockfd, (const struct sockaddr*) &their_addr, sizeof(their_addr))==-1)
    {
    	printf("connecting failed\n");
    	close(sockfd);
    	exit(1);
    }
    	printf("connected to server %s:%i\n",inet_ntoa(their_addr.sin_addr),serverPort);
    	resetScreen();
    	display();
}
    
int display()
{
	if(send(sockfd, array, BUFLEN, 0)==-1)
    	{
		printf("could not send\n");
	    	close(sockfd);
	    	free(array);
		return 0;
	}
    	//close(sockfd);
	return 1;
}

void putNumber(int n, int x, int y)
{
	if((n==4) | (n==5) | (n==7))
		writeToArray(1,getPos(x,y));
	else
		writeToArray(0,getPos(x,y));
	if((n==1) | (n==4))
		writeToArray(0,getPos(x+1,y));
	else
		writeToArray(1,getPos(x+1,y));
	if((n==1) | (n==4) | (n==5) | (n==7))
		writeToArray(1,getPos(x+2,y));
	else
		writeToArray(0,getPos(x+2,y));
		
	
	if((n==1) | (n==7))
		writeToArray(0,getPos(x,y+1));
	else
		writeToArray(1,getPos(x,y+1));
	if(n==1)
		writeToArray(1,getPos(x+1,y+1));
	else
		writeToArray(0,getPos(x+1,y+1));
	if((n==5) | (n==6))
		writeToArray(0,getPos(x+2,y+1));
	else
		writeToArray(1,getPos(x+2,y+1));
		
	
	if((n==3) | (n==7))
		writeToArray(0,getPos(x,y+2));
	else
		writeToArray(1,getPos(x,y+2));
	if((n==5) | (n==6))
		writeToArray(0,getPos(x+2,y+2));
	else
		writeToArray(1,getPos(x+2,y+2));
	
	if((n==0) | (n==4) | (n==6) | (n==8) | (n==9))
		writeToArray(1,getPos(x,y+3));
	else
		writeToArray(0,getPos(x,y+3));
	if(n==5)
		writeToArray(1,getPos(x+1,y+3));
	else
		writeToArray(0,getPos(x+1,y+3));
	if((n==5) | (n==6))
		writeToArray(0,getPos(x+2,y+3));
	else
		writeToArray(1,getPos(x+2,y+3));
		
		
	if((n==0) | (n==4) | (n==6) | (n==8))
		writeToArray(1,getPos(x,y+4));
	else
		writeToArray(0,getPos(x,y+4));
	if((n==3) | (n==4) | (n==6) |(n>=8))
		writeToArray(1,getPos(x+1,y+4));
	else
		writeToArray(0,getPos(x+1,y+4));
	if((n==3) | (n==6))
		writeToArray(0,getPos(x+2,y+4));
	else
		writeToArray(1,getPos(x+2,y+4));
		
		
	if((n==0) | (n==6) | (n==8))
		writeToArray(1,getPos(x,y+5));
	else
		writeToArray(0,getPos(x,y+5));
	if((n==2) | (n==7))
		writeToArray(1,getPos(x+1,y+5));
	else
		writeToArray(0,getPos(x+1,y+5));
	if((n==2) | (n==7))
		writeToArray(0,getPos(x+2,y+5));
	else
		writeToArray(1,getPos(x+2,y+5));
		
		
	if((n==0) | (n==2) | (n==6) | (n==8))
		writeToArray(1,getPos(x,y+6));
	else
		writeToArray(0,getPos(x,y+6));
	if(n==7)
		writeToArray(1,getPos(x+1,y+6));
	else
		writeToArray(0,getPos(x+1,y+6));
	if((n==2) | (n==7))
		writeToArray(0,getPos(x+2,y+6));
	else
		writeToArray(1,getPos(x+2,y+6));
		
	if((n==1) | (n==4) | (n==7) | (n==9))
		writeToArray(0,getPos(x,y+7));
	else
		writeToArray(1,getPos(x,y+7));
	if(n==7)
		writeToArray(1,getPos(x+1,y+7));
	else
		writeToArray(0,getPos(x+1,y+7));
	if((n==2) | (n==7))
		writeToArray(0,getPos(x+2,y+7));
	else
		writeToArray(1,getPos(x+2,y+7));
		
		
	if(n==2)
		writeToArray(1,getPos(x,y+8));
	else
		writeToArray(0,getPos(x,y+8));
	if((n==1) | (n==4))
		writeToArray(0,getPos(x+1,y+8));
	else
		writeToArray(1,getPos(x+1,y+8));
	if((n==1) | (n==2) | (n==4))
		writeToArray(1,getPos(x+2,y+8));
	else
		writeToArray(0,getPos(x+2,y+8));
}

void putSmallChar(char c, int x, int y)
{
	//0
	switch (c)
	{
		case 'A':
		case 'C':
		case 'G':
		case 'I':
		case 'J':
		case 'O':
		case 'Q':
		case 'S':
		case '.':
		case '!':
		case ',':
			writeToArray(0,getPos(x,y));
			break;
		default:
			writeToArray(1,getPos(x,y));
	}
	//1
	switch (c)
	{
		case 'H':
		case 'K':
		case 'L':
		case 'N':
		case 'U':
		case 'V':
		case 'W':
		case 'X':
		case 'Y':
		case '4':
		case '6':
		case '.':
		case ',':
			writeToArray(0,getPos(x+1,y));
			break;
		default:
			writeToArray(1,getPos(x+1,y));
	}
	//2
	switch (c)
	{
		case 'A':
		case 'B':
		case 'D':
		case 'I':
		case 'J':
		case 'L':
		case 'O':
		case 'Q':
		case 'R':
		case 'Z':
		case '1':
		case '2':
		case '6':
		case '.':
		case ',':
			writeToArray(0,getPos(x+2,y));
			break;
		default:
			writeToArray(1,getPos(x+2,y));
	}
	//3
	switch (c)
	{
		case 'I':
		case 'J':
		case 'S':
		case 'T':
		case 'X':
		case 'Y':
		case 'Z':
		case '1':
		case '2':
		case '3':
		case '5':
		case '7':
		case '.':
		case '!':
		case ',':
		case '?':
			writeToArray(0,getPos(x,y+1));
			break;
		default:
			writeToArray(1,getPos(x,y+1));
	}
	//4
	switch (c)
	{
		case 'C':
		case 'D':
		case 'G':
		case 'L':
		case 'O':
		case 'Q':
		case 'U':
		case 'V':
		case '7':
		case '0':
		case '?':
		case '.':
			writeToArray(0,getPos(x+1,y+1));
			break;
		default:
			writeToArray(1,getPos(x+1,y+1));
	}
	//5
	switch (c)
	{
		case 'C':
		case 'E':
		case 'F':
		case 'G':
		case 'I':
		case 'J':
		case 'K':
		case 'L':
		case 'S':
		case 'T':
		case 'X':
		case 'Y':
		case 'Z':
		case '1':
		case '2':
		case '5':
		case '.':
		case ',':
			writeToArray(0,getPos(x+2,y+1));
			break;
		default:
			writeToArray(1,getPos(x+2,y+1));
	}
	//6
	switch (c)
	{
		case 'C':
		case 'I':
		case 'O':
		case 'Q':
		case 'T':
		case 'V':
		case 'Y':
		case 'Z':
		case '1':
		case '4':
		case '7':
		case '9':
			writeToArray(0,getPos(x,y+2));
			break;
		default:
			writeToArray(1,getPos(x,y+2));
	}
	//7
	switch (c)
	{
		case 'A':
		case 'F':
		case 'H':
		case 'J':
		case 'K':
		case 'M':
		case 'N':
		case 'P':
		case 'R':
		case 'X':
		case '4':
		case '9':
		case '?':
		case '.':
		case '!':
		case ',':
			writeToArray(0,getPos(x+1,y+2));
			break;
		default:
			writeToArray(1,getPos(x+1,y+2));
	}
	//8
	switch (c)
	{
		case 'B':
		case 'D':
		case 'F':
		case 'I':
		case 'J':
		case 'L':
		case 'O':
		case 'P':
		case 'S':
		case 'T':
		case 'V':
		case 'Y':
		case '1':
		case '5':
		case '7':
		case '?':
		case '.':
		case '!':
		case ',':
			writeToArray(0,getPos(x+2,y+2));
			break;
		default:
			writeToArray(1,getPos(x+2,y+2));
	}
}

void putChar(char c, int x, int y)
{
	if((x>=0)&&(x<=24))
	{
		//0
		switch (c)
		{
			case 'A':
			case 'C':
			case 'G':
			case 'Q':
			case 'S':
			case '0':
			case '1':
			case '2':
			case '6':
			case '8':
			case '9':
			case '.':
			case '!':
			case ',':
				writeToArray(0,getPos(x,y));
				break;
			default:
				writeToArray(1,getPos(x,y));
		}
		//3
		switch (c)
		{
			case 'I':
			case 'J':
			case 'T':
			case 'Z':
			case '1':
			case '3':
			case '7':
			case '?':
			case '!':
			case '.':
			case ',':
				writeToArray(0,getPos(x,y+1));
				break;
			default:
				writeToArray(1,getPos(x,y+1));
		}
		//6
		switch (c)
		{
			case 'I':
			case 'J':
			case 'T':
			case 'X':
			case 'Y':
			case 'Z':
			case '1':
			case '2':
			case '3':
			case '7':
			case '8':
			case '9':
			case '?':
			case '!':
			case '.':
			case ',':
				writeToArray(0,getPos(x,y+2));
				break;
			default:
				writeToArray(1,getPos(x,y+2));
		}
		//9
		switch (c)
		{
			case 'I':
			case 'J':
			case 'S':
			case 'T':
			case 'Y':
			case '1':
			case '2':
			case '3':
			case '4':
			case '5':
			case '7':
			case '9':
			case '.':
			case '!':
			case ',':
			case '?':
				writeToArray(0,getPos(x,y+3));
				break;
			default:
				writeToArray(1,getPos(x,y+3));
		}
		//12
		switch (c)
		{
			case 'C':
			case 'G':
			case 'Q':
			case 'T':
			case 'V':
			case 'Y':
			case '0':
			case '1':
			case '4':
			case '6':
			case '7':
			case '8':
			case '9':
			case '.':
			case '!':
			case '?':
				writeToArray(0,getPos(x,y+4));
				break;
			default:
				writeToArray(1,getPos(x,y+4));
		}
	}
	
	if((x>=-1)&&(x<=23))
	{
		//1
		switch (c)
		{
			case 'H':
			case 'K':
			case 'L':
			case 'M':
			case 'N':
			case 'U':
			case 'V':
			case 'W':
			case 'X':
			case 'Y':
			case '1':
			case '4':
			case '.':
			case ',':
				writeToArray(0,getPos(x+1,y));
				break;
			default:
				writeToArray(1,getPos(x+1,y));
		}
		//4
		switch (c)
		{
			case 'I':
			case 'M':
			case 'N':
			case 'T':
			case '1':
			case '!':
				writeToArray(1,getPos(x+1,y+1));
				break;
			default:
				writeToArray(0,getPos(x+1,y+1));
		}
		//7
		switch (c)
		{
			case 'C':
			case 'D':
			case 'G':
			case 'J':
			case 'L':
			case 'O':
			case 'Q':
			case 'U':
			case 'V':
			case '0':
			case '1':
			case '2':
			case '.':
			case ',':
				writeToArray(0,getPos(x+1,y+2));
				break;
			default:
				writeToArray(1,getPos(x+1,y+2));
		}
		//10
		switch (c)
		{
			case 'I':
			case 'N':
			case 'Q':
			case 'T':
			case 'W':
			case 'Y':
			case '2':
			case '7':
			case ',':
				writeToArray(1,getPos(x+1,y+3));
				break;
			default:
				writeToArray(0,getPos(x+1,y+3));
		}
		//13
		switch (c)
		{
			case 'A':
			case 'F':
			case 'H':
			case 'K':
			case 'M':
			case 'N':
			case 'P':
			case 'R':
			case 'W':
			case 'X':
			case '1':
			case '4':
			case ',':
				writeToArray(0,getPos(x+1,y+4));
				break;
			default:
				writeToArray(1,getPos(x+1,y+4));
		}
	}

	if((x>=-2)&&(x<=22))
	{
		//2
		switch (c)
		{
			case 'A':
			case 'B':
			case 'D':
			case 'L':
			case 'P':
			case 'Q':
			case 'R':
			case '0':
			case '2':
			case '3':
			case '6':
			case '8':
			case '9':
			case '.':
			case '!':
			case ',':
				writeToArray(0,getPos(x+2,y));
				break;
			default:
				writeToArray(1,getPos(x+2,y));
		}
		//5
		switch (c)
		{
			case 'C':
			case 'E':
			case 'F':
			case 'G':
			case 'I':
			case 'L':
			case 'S':
			case 'T':
			case '5':
			case '6':
			case '!':
			case '.':
			case ',':
				writeToArray(0,getPos(x+2,y+1));
				break;
			default:
				writeToArray(1,getPos(x+2,y+1));
		}
		//8
		switch (c)
		{
			case 'B':
			case 'C':
			case 'G':
			case 'I':
			case 'K':
			case 'L':
			case 'P':
			case 'R':
			case 'T':
			case 'X':
			case 'Y':
			case 'Z':
			case '3':
			case '5':
			case '6':
			case '7':
			case '8':
			case '?':
			case '!':
			case '.':
			case ',':
				writeToArray(0,getPos(x+2,y+2));
				break;
			default:
				writeToArray(1,getPos(x+2,y+2));
		}
		//11
		switch (c)
		{
			case 'C':
			case 'E':
			case 'F':
			case 'I':
			case 'L':
			case 'P':
			case 'T':
			case 'Y':
			case 'Z':
			case '2':
			case '7':
			case '.':
			case '!':
			case '?':
			case ',':
				writeToArray(0,getPos(x+2,y+3));
				break;
			default:
				writeToArray(1,getPos(x+2,y+3));
		}
		//14
		switch (c)
		{
			case 'B':
			case 'D':
			case 'F':
			case 'J':
			case 'P':
			case 'S':
			case 'T':
			case 'V':
			case 'Y':
			case '0':
			case '3':
			case '5':
			case '6':
			case '7':
			case '8':
			case '9':
			case ',':
			case '.':
			case '!':
			case '?':
				writeToArray(0,getPos(x+2,y+4));
				break;
			default:
				writeToArray(1,getPos(x+2,y+4));
		}
	}
}
